---
    - name: Install BOS 
      hosts: ubuntu
      become: true

      vars:
        - instance_user: 'ubuntu'
        - project_dir: '/usr/local/lib/bos-auto'
        - chains_file: 'utilities/chains.py'
        - bos_auto_service: 'utilities/bos-auto.service'
        - bos_auto_worker_service: 'utilities/bos-auto-worker.service'

      tasks:
        - name: Install dependencies
          become: yes
          apt:
            name: "{{ packages }}"  
          vars:
            packages:    
            - libffi-dev
            - libssl-dev
            - python-dev
            - python3-dev
            - python3-pip
            - libsecp256k1-dev
            - python3-venv
            - build-essential
            - mongodb
            - redis-server
            - python-setuptools
            - pkg-config
            state: latest 
      
        - name: Start service mongodb, if not started
          service:
            name: mongodb
            state: started

        - name: Start service redis, if not started
          service:
            name: redis
            state: started

        - name: Create bos-auto directory if it doesn't exist
          become: yes
          file:
            path: "{{ project_dir }}"
            state: directory
            mode: '0755'

        - name: Creates python virtual env 
          pip: 
            name: bos-auto
            virtualenv: /usr/local/lib/bos-auto/env
            virtualenv_command: 'python3 -m venv'

        - name: Change ownership to instance user
          file:
            path: "{{ project_dir }}"
            owner: "{{ instance_user }}"
            group: "{{ instance_user }}"
            state: directory
            recurse: yes

        - name: Downloads the config file
          become_user: "{{ instance_user }}"
          get_url:
            url: https://raw.githubusercontent.com/peerplays-network/bos-auto/master/config-example.yaml
            dest: "{{ project_dir }}/config.yaml"
        
        - name: Updates chain list with the chain file 
          become_user: " {{ instance_user }}"
          copy:
            src: "{{ chains_file }}"
            dest: "{{ project_dir }}/env/lib/python3.6/site-packages/peerplaysbase/chains.py"
            owner: "{{ instance_user }}"
            group: "{{ instance_user }}"

        - name: Adds the bos-auto service file
          copy:
            src: "{{ bos_auto_service }}"
            dest: /etc/systemd/system/bos-auto.service

        - name: Adds the bos-auto-worker service file
          copy:
            src: "{{ bos_auto_worker_service }}"
            dest: /etc/systemd/system/bos-auto-worker.service
